// ==UserScript==
// @name        youtube.com
// @namespace   https://userscripts.skaarup.dev
// @match       https://www.youtube.com/watch*
// @version     1.0
// @author      nws
// @description youtube video playback rate changer
// @updateURL   https://userscripts.skaarup.dev/scripts/youtube.user.js
// @downloadURL https://userscripts.skaarup.dev/scripts/youtube.user.js
// @grant       none
// @grant       GM_registerMenuCommand
// ==/UserScript==

GM_registerMenuCommand(
  'PlaybackRate Up',
  (event) => {
    const videos = Array.from(document.querySelectorAll('video'));

    for (const video of videos) {
      if (video.paused) continue;

      const currentPlaybackRate = video.playbackRate;

      video.playbackRate = currentPlaybackRate + 0.5;

      console.log(`PlaybackRate changed from ${currentPlaybackRate} to ${video.playbackRate}`);
    }
  },
  {
    title: 'increase video playbackRate by 0.5'
  }
);

GM_registerMenuCommand(
  'PlaybackRate Down',
  (event) => {
    const videos = Array.from(document.querySelectorAll('video'));

    for (const video of videos) {
      if (video.paused) continue;

      const currentPlaybackRate = video.playbackRate;

      if (currentPlaybackRate < 0.5) continue;

      video.playbackRate = currentPlaybackRate - 0.5;

      console.log(`PlaybackRate changed from ${currentPlaybackRate} to ${video.playbackRate}`);
    }
  },
  {
    title: 'decrease video playbackRate by 0.5'
  }
);
